// RS-232C loopback test                          
//   19200bps, data=8bit, stop bit=1bit, non parity, no flow control   
//
//   RS-232C --> INV --> RC14(UARX) ------------------+  loopback
//                                                    |  with
//   RS-232C <-- RB7 <-- INV <-- RB6 <-- RC13(UATX) --+  modification

#include <p30f2012.h>     // include dsPIC30F2012 header file

int main(void) {
  unsigned data;

  TRISBbits.TRISB6=1;              // RB6 is input  
  TRISBbits.TRISB7=0;              // RB7 is output  

  U1MODE=0x8400;                   // use U1ATX(UATX) 
  U1BRG =95;                       // 19200bps (29.48MHz/16/19200-1=95)
  U1STA =0x0400;                   // start transmission (UTXEN=1)

  while (1) {
    if (U1STAbits.URXDA==1) {      // if RX data exists
      data=U1RXREG;                // read RX data
      U1TXREG=data+1;              // send TX data with data modification
    }
    PORTBbits.RB7=~PORTBbits.RB6;  // RB7 <-- ~RB6 (invert)
  }

}
