// color LED driver
// output pin = RB6, RB7, RB8

#include <p30f2012.h>       // include dsPIC30F2012 header file
#include <math.h>           // for cos(), pow() function

#define PERIOD 1000         // pulse period
#define LOOP6  6007         // (prime number)
#define LOOP7  7177         // (prime number)
#define LOOP8  8447         // (prime number)
#define PI     3.1415926    // circle ratio

int main(void) {
  unsigned i;
  unsigned duty6, duty7, duty8;
  unsigned count6, count7, count8;

  //ADPCFG=0xffff;          // disable all A/D input pin

  TRISBbits.TRISB6=0;       // RB6 is output  
  TRISBbits.TRISB7=0;       // RB7 is output
  TRISBbits.TRISB8=0;       // RB8 is output

  duty6=0; count6=0;   
  duty7=0; count7=LOOP7/2; 
  duty8=0; count8=LOOP8/3;

  while(1) {                             
    PORTB=0;      
    for (i=0; i<PERIOD; i=i+1) {
      if (duty6<i) PORTBbits.RB6=1;      
      if (duty7<i) PORTBbits.RB7=1;
      if (duty8<i) PORTBbits.RB8=1;
      asm("repeat #200");   // repeat next instruction
      asm("nop");           // wait...
    }                      
    count6=(count6+1)%LOOP6;
    count7=(count7+1)%LOOP7;
    count8=(count8+1)%LOOP8;
    duty6=0.99*PERIOD*pow(400, cos(44.0*pow((float)count6/LOOP6-0.5, 2.0)))/400+3;
    duty7=0.99*PERIOD*pow(400, cos(44.0*pow((float)count7/LOOP7-0.5, 2.0)))/400+3;
    duty8=0.99*PERIOD*pow(400, cos(44.0*pow((float)count8/LOOP8-0.5, 2.0)))/400+3;
  }

}
