// read SW1/SW2 (RD8/RD9) and sound speaker (RB6)
//   SW2 on  : sound speaker
//   SW1=LD  : 500Hz tone (2ms period)
//   SW1=RUN : 250Hz tone (4ms period)
#include <p30F2012.h>

//----------------------------------------------------------------------
// sleep function : sleep_ms(x) = x[ms] sleep

void sleep_ms(unsigned wait) {
  unsigned i, j;

  for (i=0; i<wait; i=i+1) {           // time consuming loop
    for (j=0; j<418; j=j+1) {         // time consuming loop
      asm("nop"); asm("nop");          // NOP instruction
    }
  }
}

//----------------------------------------------------------------------

void main(void) {
  TRISBbits.TRISB6=0;                  // set TRIS register, RB6 is output
  TRISDbits.TRISD8=1;                  // set TRIS register, RD8 is input
  TRISDbits.TRISD9=1;                  // set TRIS register, RD9 is input
  while(1) {                           // forever loop
    if (PORTDbits.RD9==1) {            // if SW1 is ON
      if (PORTDbits.RD8==0) {          // if SW2 is LD pisition 
        sleep_ms(1);                   // sleep 1ms
      } else {                         // SW2 is RUN position
        sleep_ms(2);                   // sleep 2ms
      }
      PORTBbits.RB6=~PORTBbits.RB6;    // toggle speaker output (RB6)
    } else {                           // SW1 is OFF
      PORTBbits.RB6=0;                 // RB6 is Lo (for NPN driver)
    }
  }
}